﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
'Handler class
Sub Class_Globals
	'Dim u As jUtilities
	Dim t As Timer
	Dim os As OutputStream
End Sub

Public Sub Initialize
	t.Initialize("Timer1",1000)
End Sub

Sub Handle(req As ServletRequest, resp As ServletResponse)
	resp.ContentType = "text/event-stream"
	resp.SetHeader("Cache-Control","no-cache")
	resp.setHeader("Connection", "keep-alive")
	resp.CharacterEncoding = "UTF-8"
	
	resp.Status = 200
	
	os = resp.OutputStream
	
	SendMessage("123","event: open")	
	SendMessage("123","retry: 5000")
	
	t.Enabled = True
	
	StartMessageLoop
End Sub

Sub Timer1_Tick
	Dim message As String = "data: The server time is: " & DateTime.Now
	Try
		SendMessage("123", message)
	Catch
		Log("Disconnected")
		t.Enabled = False
		StopMessageLoop
	End Try
End Sub

Sub SendMessage(id As String, message As String)	
	Dim FinalMessage As String
	
	If id.Length > 0 Then FinalMessage = $"id: ${id}${Chr(10)}"$
	
	FinalMessage = FinalMessage & message & Chr(10) & Chr(10)
	
	os.WriteBytes(FinalMessage.GetBytes("UTF-8"),0,FinalMessage.Length)
	os.Flush
End Sub

